<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\ItemModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;

class ItemService extends BaseService
{
    /**
     * ItemService constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->model = new ItemModel();
    }

    /**
     *  index function that get all data from database by default
     * @return array|static[]
     */
    public function index()
    {
        return $this->model->getQuery()->get();
    }


    /**
     *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
     * @param array $input
     * @return array
     */
    public function paging(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));

        $this->model->joinRelationKapalId()->getQuery()->select([
            "item.*",
            "kapalId.namaKapal"])
            ->whereIn("item.type_id", $auth->arrCategory);

            if($auth->aplikasi != "HO") { 
                $this->model->getQuery()->where("item.kapalId", "=", $auth->kapalId); 
            }
        $this->model->paging()->filter()->sorting();
        return $this->model->paging()->getPaging();
    }

    public function pagingModal(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));

        $this->model->joinRelationKapalId()->getQuery()->select([
                        "item.*", "item.item_price AS harga",
                        "kapalId.namaKapal"
                    ])
                    ->where("item.enabled_flex", "=", "Y")
                    ->whereIn("item.type_id", $auth->arrCategory)
                    ->where("item.type_id", "!=", $auth->sysParams->PELNIMEAL)
                    ->where("item.kapalId", "=", $auth->kapalId);

            if($auth->aplikasi != "HO") { 
                $this->model->getQuery()->where("item.kapalId", "=", $auth->kapalId); 
            }
        $this->model->paging()->filter()->sorting();
        return $this->model->paging()->getPaging();
    }

    public function pagingModalMakanan(Request $request)
    {
        $auth = json_decode($request->session()->get('auth'));

        $this->model->joinRelationKapalId()->getQuery()->select([
                        "item.*",
                        "item.item_price AS harga",
                        "kapalId.namaKapal"
                    ])
                    ->where("item.enabled_flex", "=", "Y")
                    ->whereIn("item.type_id", $auth->arrCategory)
                    ->where("item.type_id", "=", $auth->sysParams->PELNIMEAL)
                    ->where("item.kapalId", "=", $auth->kapalId);

            if($auth->aplikasi != "HO") { 
                $this->model->getQuery()->where("item.kapalId", "=", $auth->kapalId); 
            }
        $this->model->paging()->filter()->sorting();
        return $this->model->paging()->getPaging();
    }

    /**
     *  get one raw row data from table by id
     *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
     *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
     *  and you want to take value like this $model->fieldname
     * @param $id
     * @return ItemModel
     */
    public function show($id, $kapalId = "")
    {
        $kapalId = intval($kapalId);
        $this->model->joinRelationKapalId()->getQuery()
        ->select(["item.*", "kapalId.namaKapal"])
        ->where("item.id", "=", $id);

        if(! empty($kapalId) && $kapalId > 0) {
            $this->model->getQuery()->where("item.kapalId", "=", $kapalId);
        }

        $model = $this->model->getQuery()->first();
        return $model;
    }


    /**
     *  this is a base function for storing data you with transaction by default
     *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
     * @param array $input
     * @return ItemModel
     * @throws \Exception
     */
    public function store($input)
    {
        $this->model->fill($input);
        $maxID = $this->model->getQuery()->orderBy("id", "desc")->first();
        if( is_object($maxID) ) { $this->model->id = $maxID->id + 1; }  else { $this->model->id = 1; }
        
        if (!$this->model->save()) {
            throw new \Exception();
        }
        return $this->model;
    }


    /**
     * this function will delete much data, in one action
     * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
     * you can remove this main alogorithm with your business requirement like soft delete or anything you want
     * @param $ids
     */
    public function delete($ids)
    {
        $params = explode(".", $ids);
        $this->model->deleteBulk("id", $params);
    }


    /**
     *  this is a base function for update and delete data by default.
     *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or
     *  you can add multiple relation proses after update in this function
     * @param $id
     * @param array $input
     * @return ItemModel
     * @throws \Exception
     */
    public function update($id, $input)
    {
        $item = ItemModel::find($id);
        $item->fill($input);
        if (!$item->update()) {
            throw new \Exception();
        }
        return $item;
    }


    /**
     *  this function will be confirting paging property into file excel
     *  the main library is base on excel spreadsheet library
     * @param array $input
     * @return array|static[]
     */
    public function exportToExcel($input = array())
    {
        return $this->model->getQuery()->where("item.enabled_flex", "=", "Y")->get();
    }

    public function getList(Request $request, $conditions = [])
    {
        $this->model->joinRelationKapalId()->getQuery()->select(["item.*", "kapalId.namaKapal"]);

        if(! empty($conditions)) {
            foreach($conditions as $condition) {		
                if($condition["operator"] == "IN") {
                    $this->model->getQuery()->whereIn($condition["field"], $condition["value"]);
                } else {
                    $this->model->getQuery()->where($condition["field"], $condition["operator"], $condition["value"]);
                }
                
            }
        }

        $model = $this->model->getQuery()->where("item.enabled_flex", "=", "Y")->get();
        return $model;
    }

    public function getMealType()
    {
        return $this->model->getQuery()->selectRaw(' DISTINCT "item"."meal_type" ')->whereRaw(' "item"."meal_type" IS NOT NULL ')->groupBy("item.meal_type")->get();
    }
}